package com.ustadmobile.ustadapiconsumer.util.ext

import android.content.Context
import com.ustadmobile.httpoveripc.client.HttpOverIpcClient
import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.launch
import kotlinx.serialization.json.Json
import rawhttp.core.RawHttp

data class IpcRequestContext(
    val ipcClient: HttpOverIpcClient,
    val rawHttp: RawHttp,
    val json: Json,
)

fun CoroutineScope.launchIpcRequest(
    context: Context,
    block: suspend (IpcRequestContext) -> Unit,
) {
    val ipcActivity = context.ipcActivity()
    val ipcClient = ipcActivity.ipcClient ?: return
    val rawHttp = ipcActivity.rawHttp
    val json = ipcActivity.json

    launch {
        block(IpcRequestContext(ipcClient, rawHttp, json))
    }
}
